unit hiMemoryStatus;

interface

uses Kol,Share,Windows,Debug;

type
  {$ifdef VER120}UInt64 = Int64;{$endif}
  {$ifdef F_P}UInt64 = Int64;{$endif}

  
  TMemoryStatusEx = record
    dwLength: DWORD;
    dwMemoryLoad: DWORD;
    ullTotalPhys: UInt64;
    ullAvailPhys: UInt64;
    ullTotalPageFile: UInt64;
    ullAvailPageFile: UInt64;
    ullTotalVirtual: UInt64;
    ullAvailVirtual: UInt64;
    ullAvailExtendedVirtual: UInt64;
  end;
  PMemoryStatusEx = ^TMemoryStatusEx;

  

  THIMemoryStatus = class(TDebug)
    private
      lpMemoryStatus: TMemoryStatusEx;
    public
      _prop_Scale: Byte;

      procedure _work_Refresh(var _Data: TData; Index: Word);
      procedure _var_RAM(var _Data: TData; Index: Word);
      procedure _var_RAM_free(var _Data: TData; Index: Word);
      procedure _var_PageFile(var _Data: TData; Index: Word);
      procedure _var_PageFile_free(var _Data: TData; Index: Word);
      procedure _var_Virtual(var _Data: TData; Index: Word);
      procedure _var_Virtual_free(var _Data: TData; Index: Word);
  end;
  
  function GlobalMemoryStatusEx(var Buffer: TMemoryStatusEx): LongBool; stdcall; external 'kernel32' name 'GlobalMemoryStatusEx';

implementation

const
  Sc: array[0..2] of Cardinal = (1,1024,1024*1024);

procedure THIMemoryStatus._work_Refresh;
begin
  lpMemoryStatus.dwLength := SizeOf(lpMemoryStatus);
  GlobalMemoryStatusEx(lpMemoryStatus);
end;

procedure THIMemoryStatus._var_RAM;
begin
  dtReal(_Data, lpMemoryStatus.ullTotalPhys div Sc[_prop_Scale]);
end;

procedure THIMemoryStatus._var_RAM_free;
begin
  dtReal(_Data, lpMemoryStatus.ullAvailPhys div Sc[_prop_Scale]);
end;

procedure THIMemoryStatus._var_PageFile;
begin
  dtReal(_Data, lpMemoryStatus.ullTotalPageFile div Sc[_prop_Scale]);
end;

procedure THIMemoryStatus._var_PageFile_free;
begin
  dtReal(_Data, lpMemoryStatus.ullAvailPageFile div Sc[_prop_Scale]);
end;

procedure THIMemoryStatus._var_Virtual;
begin
  dtReal(_Data, lpMemoryStatus.ullTotalVirtual div Sc[_prop_Scale]);
end;

procedure THIMemoryStatus._var_Virtual_free;
begin
  dtReal(_Data, lpMemoryStatus.ullAvailVirtual div Sc[_prop_Scale]);
end;

end.
